; Alternative or added functionality to the OM package

(in-package :om)

; A Function that transforms a list of midicents or chord-list into its counterpart in a harmony field.

(defun counterpart (box item)
  (let ((new (om-abs (l- box item))))
    (l-nth box (position (list-min new) new) )))

(defun snap (box  field  type )
  (let* ((box (if (equal type 'freq) (mc2f  box) box))
         (field (if (equal type 'freq) (mc2f  field) field))
         (result))
    (dolist  (item box)
      (push  (counterpart field item) result))
    (nreverse (if (equal type 'freq) (f2mc  result) result))))

(defmethod! om-snap ((box list) (field list) 
                            &optional (type 'midics))
   :initvals '('(6000 6400 6700) '(6200 6500 6900) 'midics)
   :menuins '((2 (("Midicents" 'midics) ("Freq. (Hz)" 'freq))))
   :indoc '("box" "field" "type")
   :icon '(150)
   :doc "Transforms a list of midicents/frequencies or a chord-list into its counterpart in a harmony field."
   
   (let ((box (if (atom (car box)) (list box) box)))
     (car-mapcar  'snap  box field type)))
